﻿// url to download currency table
var url = "http://finance.yahoo.com/currency";

// number of contant of currency rate table must be 42.
var N_CURR_TABLE = 42;

var eachCurrName = new Array(N_CURR_TABLE);
eachCurrName[0]  = "USDJPY"
eachCurrName[13] = "EURJPY"
eachCurrName[19] = "CADJPY"
eachCurrName[25] = "GBPJPY"
eachCurrName[31] = "AUDJPY"
eachCurrName[37] = "CHFJPY"

var eachCurrRate = new Array(N_CURR_TABLE);

// update interval of currency rate.
var UPDATE_INTERVAL = 10 * 60 * 1000;
// var UPDATE_INTERVAL = 3000;

var request = null;
/**
 * Indicates whether the gadget is minimized.
 * The application will need to know this because
 * it behaves and draws differently when minimized.
 */
var _minimized = false;

// update interval of currency rate on caption.
var UPDATE_CAPTION_INTERVAL = 10 * 1000;
var token_caption = null;
var current_currency_no = 0;

function view_onMinimuze() {
  _minimized = true;
  current_currency_no = 0;
  updateCaption();
  token_caption = view.setInterval("updateCaption()", UPDATE_CAPTION_INTERVAL);
}

function view_onRestore() {
  _minimized = false;
  // While the gadget was minimized, the caption (titlebar text)
  // was changed to display the time.
  // The regular caption must now be restored.
  view.caption = GADGET_NAME;
  clearInterval(token_caption);
}

function updateCaption() {
  if (! request)
    return;

  view.caption = eachCurrName[current_currency_no] + '  ' + eachCurrRate[current_currency_no];

  switch (current_currency_no) {
    case 0:
      current_currency_no = 13;
      break;
    case 13:
      current_currency_no = 19;
      break;
    case 19:
      current_currency_no = 25;
      break;
    case 25:
      current_currency_no = 31;
      break;
    case 31:
      current_currency_no = 37;
      break;
    case 37:
      current_currency_no = 0;
      break;
  }
}

function view_onOpen() {
  debug.trace("view_onOpen()");

  undispRate();
  requestRate();

  view.setInterval("requestRate()", UPDATE_INTERVAL);
}

/*
 * Un-display the currency rate to the gadget
 */
function undispRate() {
  debug.trace("undispRate()");

  rate0.innerText = "-";
  rate1.innerText = "-";
  rate2.innerText = "-";
  rate3.innerText = "-";
  rate4.innerText = "-";
  rate5.innerText = "-";
}

/*
 * Update the currency rate to the gadget
 */
function requestRate() {
  debug.trace("requestRate()");

  request = new XMLHttpRequest();
  request.onreadystatechange = updateRate;

  try {
    request.open("GET", url, true);
    request.setRequestHeader('If-Modified-Since', 'Wed, 15 Nov 1995 00:00:00 GMT');
    request.send();
  } catch(e) {
    debug.warn('Could not retrieve feed: ' + e.message);
    undispRate();
    return;
  }
}

/*
 * Update the currency rate to the gadget
 */
function updateRate() {
  if (request.readyState != 4) {
    return;
  }
  if (request.status != 200) {
    return;
  }

  currRate = request.responseText.match(/<td align="right" class="yfnc_tabledata1">([0-9]+\.[0-9]+)<\/td>/g);
  debug.trace("updateRate(): currRate.length: " + currRate.length);

  for (i = 0; i < N_CURR_TABLE; i++) {
    currRate[i].match(/<td align="right" class="yfnc_tabledata1">([0-9]+\.[0-9]+)<\/td>/g);
    eachCurrRate[i] = RegExp.$1;
    // debug.trace(eachCurrName[i] + eachCurrRate[i]);
  }

  // Update rate
  debug.trace("updateRate(): Rates updated: " + eachCurrRate[0] + ", " + eachCurrRate[13] + ", " + eachCurrRate[19] + ", " + eachCurrRate[25] + ", " + eachCurrRate[31] + ", " + eachCurrRate[37]);
  rate0.innerText = eachCurrRate[0];
  rate1.innerText = eachCurrRate[13];
  rate2.innerText = eachCurrRate[19];
  rate3.innerText = eachCurrRate[25];
  rate4.innerText = eachCurrRate[31];
  rate5.innerText = eachCurrRate[37];
}




